<?php
require_once 'Sct_Base.php';
class Sct_Admin extends Sct_Base
{
	public static function init()
	{
		self::initBase();
		define('SCT_SITE_PATH',	SCT_APP_PATH.'/sites/public');
		add_action('admin_init',	array('Sct_Admin', 'doBeforeHeaders'), 1);
		add_action('admin_head',	array('Sct_Admin', 'addToHead'));
	}
	public static function doBeforeHeaders()
	{
		if ($_GET['page'] == self::$name)
		{
			global $wpdb;
			$base_url = admin_url('admin.php?page=simple_click_tracker&');
			if (isset($_POST['form_vars']))
			{
				$_POST['form_vars'] = self::array_stripslashes($_POST['form_vars']);
				self::$form_vars = $_POST['form_vars'];
			}
			if (isset($_GET['action']))
			{
				self::$action = preg_replace('/[^0-9a-zA-Z\_\-]+/is', '', strtolower($_GET['action']));
			}
			if (!self::$action)
			{
				self::$action = 'index';
			}
			$file_path = SCT_SITE_PATH.'/actions/default.php';
			if (is_file($file_path))
			{
				require $file_path;
			}
			$file_path = SCT_SITE_PATH.'/actions/'.self::$action.'.php';
			if (is_file($file_path))
			{
				require $file_path;
			}
		}
	}
	public static function addToHead()
	{
		echo '<link rel="stylesheet" href="'.SCT_BASE_URL.'includes/style_admin.css" type="text/css" media="all" />';
	}
	public static function displayView()
	{
		global $wpdb;
		$base_url = admin_url('admin.php?page=simple_click_tracker&');
		require_once SCT_APP_PATH.'/Sct_Form.php';
		$layout_path = SCT_SITE_PATH.'/layouts/default.php';
		if (is_file($layout_path))
		{
			$view_path = SCT_SITE_PATH.'/views/'.self::$action.'.php';
            //echo $view_path;
			if (!is_file($view_path))
			{
				exit('Invalid View: '.$view_path);
			}
			require($layout_path);
		}
		else
		{
			exit('Invalid Layout: '.$layout_path);
		}
	}
    public static function ValidInstaLicense(){
        $logo =  plugins_url("simple_click_tracker/includes/images/NamsToolKit.png");
        echo '<div style=" padding: 1%; width: 100%; max-width: 400px; margin: auto; border-radius: 5px; ">
        <div style="width: 100%; background-color: #fff; float: left; border-radius: 5px 5px 0px 0px;">
        <p style="text-align: center;"><img src="'.$logo.'" style="clear: both;" /></p>
        </div>
        <div style="width: 100%;  float: left; border: solid 1px #ccc; box-shadow: 1px 1px 8px #ccc">';
         if(isset($_POST['cmd']) && $_POST['cmd']=='stc_simple_click_tracker'){
                $key = trim($_POST['stc_license_key']);
                $response = Sct_Admin::ApproveKeyInsta($key,get_site_url() );
                if($response->status=='Error'){
                    echo "<div class='error'><p>".$response->message."</p></div>";
                    Sct_Admin::UdateDbStatus(0);
                }else if($response->status=='Success'){
                    update_option("rlm_license_key_simple_click_tracker",$key);
                    Sct_Admin::UdateDbStatus(1);
                    echo "<div class='updated'><p><b>Congratulations:</b> Your license is activated.</p></div>";
                    echo '<br />
                        <p style="text-align: center;"><a href="'.admin_url().'admin.php?page=simple_click_tracker"><input type="button" class="button-primary" value="Go To Simple Click Tracker" /></a></p>
                        <br />
                        </div>';
                    die();
                }else{
                    echo "<div class='update-nag'>An error has occurred. Please Try Again.</div>";
                }
            }
         echo '<form method="post" action="'.admin_url().'admin.php?page=simple_click_tracker">
                    <table cellspacing="10" width="100%">
                        <tr>
                            <td><b style="font-size: 22px;">License Key</b></td>
                        </tr>
                        <tr>
                            <td><input type="text" name="stc_license_key" style="width: 100%;"  required="" /><br />
                            <span style="float: left;"><em><i> Enter Valid License Key To Activate Plugin.</i></em></span></td>
                        </tr>
                        <tr>
                            <td>
                                <input type="hidden" name="cmd" value="stc_simple_click_tracker" />
                                <p style="text-align: center;"><input type="submit" value="Activate" style=" cursor: pointer; padding: 1% 5% 1% 5%;background-color: #565656; color: #fff; font-size: 20px; font-weight: bold; border: none; border-radius: 5px;"  /></p>
                            </td>
                        </tr>
                    </table>
                </form>
            </div>
            </div>';
    }
    public static function UdateDbStatus($force)
	{
	   update_option('rlm_version_'.self::$name, SCT_VERSION);
	   update_option('rlm_last_license_check_'.self::$name, time());
       if($force==1){
	       update_option('rlm_license_status_'.self::$name, 1);
       }else{
            update_option('rlm_license_status_'.self::$name, 0); 
       }
    }
    public static function ApproveKeyInsta($key,$url=""){
       $license_key = $key;
       $url_str = "";
        if($url!=""){
            $url_str = "&site=".$url;    
        }
      $response = wp_remote_get("http://namstoolkit.com/licensemanager/manage/checkLic.php?action=check_license&productgroup=SCT&license=".$license_key.$url_str);
      $response_body = wp_remote_retrieve_body($response); 
      $response =  json_decode($response_body);
        return $response;
    }
    public static function checkValidLicense_key($key){
      $license_key = $key;
      $response = wp_remote_get("http://namstoolkit.com/licensemanager/manage/checkLic.php?action=check_license&productgroup=SCT&license=".$license_key);
      $response_body = wp_remote_retrieve_body($response); 
      $response =  json_decode($response_body);
        if( $response->status == "Success" ) {
            update_option("sctLicenseSt",0);
        } else if ( $response->status == "Expired" ) {
            $exp_date = date('Y-m-d');
            $end_date = get_option("stc_lic_expiree_date");
            if($end_date==''){
                update_option("stc_lic_expiree_date",$exp_date);
            }
            if($end_date!=''){
                update_option("sctLicenseSt",1);
                $date1=date_create($end_date);
                $date2=date_create($exp_date);
                $diff=date_diff($date1,$date2);
                $date_valid = $diff->format("%a");
                if($date_valid<3){
                    $days = 3-$date_valid;
                    echo "<div class='update-nag'>Renew your license. $days Remaining.</div>";
                }else{
                    echo "<div class='error'><p><b>Your License Key Has Expired.</b> Please contact with support.</p></div>";
                    die();
                }
            }
        } else if ( $response->status == "Suspended" ) {
            update_option("sctLicenseSt",1);
            echo "<div class='error'><p><b>Your License Key Has Suspended.</b> Please contact with support.</p></div>";
            die();
        }else if($response->status=="Error"){
            update_option("sctLicenseSt",1);
            update_option("rlm_license_key_simple_click_tracker","");
            echo '<script>
                window.location="'.admin_url().'admin.php?page=simple_click_tracker";
            </script>';
            die();
        }
    }
    public static function validateDB_afterSave($force = FALSE){
        if (stristr(site_url(), 'mynams.com') !== FALSE)
		{
			update_option('rlm_license_status_'.self::$name, 1);
			update_option('rlm_version_'.self::$name, SCT_VERSION);
			update_option('rlm_notification_'.self::$name, '');
			return 1;
		}
        if($force){
            $response = Sct_Admin::checkValidLicense_key_inside(get_option("rlm_license_key_simple_click_tracker"));
            if($response==1){
                Sct_Admin::UdateDbStatus(1);
            }else{
                Sct_Admin::UdateDbStatus(0);
            }
        }
    }
    public static function checkValidLicense_key_inside($key){
         $license_key = $key;
      $response = wp_remote_get("http://namstoolkit.com/licensemanager/manage/checkLic.php?action=check_license&productgroup=SCT&license=".$license_key);
      $response_body = wp_remote_retrieve_body($response); 
      $response =  json_decode($response_body);
        /*$api_url = "http://namstoolkit.com/!/instamember_api/license/{$license_key}";
        $ch =curl_init();
        @curl_setopt($ch, CURLOPT_URL, $api_url);
        @curl_setopt($ch, CURLOPT_USERPWD, "{$secret_key}:{$md5_hash}");
        @curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        @curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        @curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,false);
        @curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        @curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
         $error=1;
        if(curl_error($ch))
        {
            $error = 0;
        }
        curl_close($ch);
        $response = json_decode($result);*/
        if( $response->status == "Success" ) {
            $error = 1;
        } else if ( $response->status == "Expired" ) {
            $exp_date = date('Y-m-d');
            $end_date = get_option("stc_lic_expiree_date");
            if($end_date==''){
                update_option("stc_lic_expiree_date",$exp_date);
            }
            if($end_date!=''){
                $date1=date_create($end_date);
                $date2=date_create($exp_date);
                $diff=date_diff($date1,$date2);
                $date_valid = $diff->format("%a");
                if($date_valid<3){
                    $error = 1;
                }else{
                    $error = 0;
                }
            }else{
                $error = 0;
            }
        } else if ( $response->status == "Suspended" ) {
                $error = 0;
        }else if($response->status=="Error"){
                $error = 0;
        }
        return $error;
    }
	public static function upgradePlugin()
	{
		global $wpdb;
		if (file_exists(ABSPATH.'wp-admin/includes/upgrade.php'))
		{
			require_once(ABSPATH.'wp-admin/includes/upgrade.php');
		}
		else
		{
			require_once(ABSPATH.'wp-admin/upgrade-functions.php');
		}
		ob_start();
		dbDelta('CREATE TABLE `'.self::$table['click'].'` (
			`link_id` int(11) unsigned NOT NULL,
			`parent_id` int(11) unsigned NOT NULL,
			`source_link_id` int(11) unsigned NOT NULL,
			`user_id` int(11) unsigned NOT NULL,
			`date_time` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			`ip` varchar(25) NOT NULL,
			`referrer` mediumtext,
			`agent` mediumtext,
			KEY idx_link (`link_id`),
			KEY idx_path (`date_time`)
		);');
		dbDelta('CREATE TABLE `'.self::$table['domain'].'` (
			`domain_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`user_id` int(11) unsigned NOT NULL,
			`domain` varchar(255) NOT NULL,
			`redirect_to_404` text,
			`created` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			`modified` DATETIME NOT NULL,
			`active` tinyint(1) unsigned NOT NULL DEFAULT 1,
			`installed` tinyint(1) unsigned NOT NULL,
			PRIMARY KEY (`domain_id`),
			KEY idx_user (`user_id`),
			UNIQUE KEY (`domain`)
		)ENGINE=InnoDB DEFAULT CHARSET=latin1;');
		dbDelta('CREATE TABLE `'.self::$table['404_log'].'` (
			`domain_id` int(11) unsigned NOT NULL,
			`path` varchar(100) NOT NULL,
			UNIQUE KEY (`domain_id`, `path`)
		);');
		dbDelta('CREATE TABLE `'.self::$table['funnel'].'` (
			`funnel_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`user_id` int(11) unsigned NOT NULL,
			`name` varchar(255) NOT NULL,
			`conv_value` decimal(10,2) NOT NULL,
			`click_cost` decimal(10,2) NOT NULL,
			`created` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			`modified` DATETIME NOT NULL,
			PRIMARY KEY (`funnel_id`),
			KEY (`user_id`)
		);');
		dbDelta('CREATE TABLE `'.self::$table['funnel_link'].'` (
			`funnel_link_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`funnel_id` int(11) unsigned NOT NULL,
			`link_id` int(11) unsigned NOT NULL,
			`conv_value` decimal(10,2) NOT NULL,
			`click_cost` decimal(10,2) NOT NULL,
			`sort_order` int(11) unsigned NOT NULL,
			`created` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			`modified` DATETIME NOT NULL,
			PRIMARY KEY (`funnel_link_id`),
			UNIQUE KEY (`funnel_id`,`link_id`)
		);');
		dbDelta('CREATE TABLE `'.self::$table['group'].'` (
			`group_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`user_id` int(11) unsigned NOT NULL,
			`domain_id` int(11) unsigned NOT NULL,
			`name` varchar(255) NOT NULL,
			`created` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			`modified` DATETIME NOT NULL,
			PRIMARY KEY (`group_id`),
			KEY idx_user (`user_id`),
			KEY idx_domain (`domain_id`)
		);');
		dbDelta('CREATE TABLE `'.self::$table['link'].'` (
			`link_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
			`parent_id` int(11) unsigned NOT NULL,
			`user_id` int(11) unsigned NOT NULL,
			`group_id` int(11) unsigned NOT NULL,
			`domain_id` int(11) unsigned NOT NULL,
			`name` varchar(255) NOT NULL,
			`path` varchar(100) NOT NULL,
			`url` mediumtext,
			`type` varchar(15) NOT NULL,
			`has_children` tinyint(1) unsigned NOT NULL,
			`goal_link_id` int(11) unsigned NOT NULL,
			`javascript` mediumtext,
			`total_clicks` int(11) unsigned NOT NULL,
			`unique_clicks` int(11) unsigned NOT NULL,
			`first_click` DATETIME NOT NULL,
			`last_click` DATETIME NOT NULL,
			`last_check` DATETIME NOT NULL,
			`is_dead` tinyint(1) unsigned NOT NULL,
			`created` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			`modified` DATETIME NOT NULL,
			PRIMARY KEY (`link_id`),
			KEY idx_user (`user_id`),
			KEY idx_group (`group_id`),
			KEY idx_domain (`domain_id`),
			KEY idx_path (`path`)
		);');
		dbDelta('CREATE TABLE `'.self::$table['user_join'].'` (
			`parent_user_id` varchar(25) NOT NULL,
			`child_user_id` varchar(25) NOT NULL,
			`date_time` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
			KEY idx_parent (`parent_user_id`),
			KEY idx_child (`child_user_id`),
			UNIQUE KEY idx_unique (`parent_user_id`,`child_user_id`)
		);');
        dbDelta('CREATE TABLE IF NOT EXISTS `'.self::$table['funnel_link_new'].'`  (
  `funnel_link_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `funnel_url` text COLLATE utf8_unicode_ci NOT NULL,
  `red_url` text COLLATE utf8_unicode_ci NOT NULL,
  `funnel_id` int(11) NOT NULL,
  `link_id` int(11) unsigned NOT NULL,
  `conv_value` decimal(10,2) NOT NULL,
  `click_cost` decimal(10,2) NOT NULL,
  `sort_order` int(11) unsigned NOT NULL,
  `funnel_type` int(11) NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `modified` datetime NOT NULL,
  PRIMARY KEY (`funnel_link_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;');
        $wpdb->query("ALTER TABLE ".self::$table['link']." ADD `is_archived` INT NOT NULL AFTER `is_dead`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel_link']." ADD `funnel_type` INT NOT NULL AFTER `sort_order`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel']." ADD `funnel_type` INT NOT NULL AFTER `name`, ADD `no_of_up` INT NOT NULL AFTER `funnel_type`, ADD `no_of_dw` INT NOT NULL AFTER `no_of_up`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel']." ADD `start_date` VARCHAR(100) NOT NULL AFTER `created`, ADD `end_date` VARCHAR(100) NOT NULL AFTER `start_date`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel']." ADD `c_cost` VARCHAR(50) NOT NULL AFTER `name`, ADD `f_cost` VARCHAR(50) NOT NULL AFTER `c_cost`;");
        $wpdb->query("ALTER TABLE ".self::$table['user_join']." ADD `user_type` INT NOT NULL AFTER `child_user_id`;");
        $wpdb->query("ALTER TABLE ".self::$table['user_join']." ADD `assigned_domain` VARCHAR(150) NOT NULL AFTER `child_user_id`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel']." ADD `no_of_t` INT NOT NULL AFTER `no_of_dw`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel_link']." ADD `funnel_url` TEXT NOT NULL AFTER `funnel_id`, ADD `red_url` TEXT NOT NULL AFTER `funnel_url`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel_link_new']." ADD `total_click` INT NOT NULL AFTER `created`, ADD `unique_click` INT NOT NULL AFTER `total_click`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel_link_new']." ADD `conversions` INT NOT NULL AFTER `unique_click`;");
        $wpdb->query("ALTER TABLE ".self::$table['funnel_link_new']." ADD `link_order` INT NOT NULL AFTER `conversions`;");
        $wpdb->query("ALTER TABLE ".self::$table['link']." ADD `fb_title` TEXT NOT NULL AFTER `javascript`, ADD `fb_description` TEXT NOT NULL AFTER `fb_title`, ADD `fb_image` TEXT NOT NULL AFTER `fb_description`;");
		ob_end_clean();
	}
    public static function upgrade_versions(){
        global $wpdb;
        $domain_id = $wpdb->get_var('SELECT domain_id FROM '.Sct_Admin::$table['domain'].' WHERE domain = "'.addslashes($_SERVER['HTTP_HOST']).'"');
        if(!(int)$domain_id)
        {
		     $wpdb->insert(Sct_Admin::$table['domain'], array('domain' => $_SERVER['HTTP_HOST']));
        }else{
            $wpdb->update(Sct_Admin::$table['domain'], array('domain' => $_SERVER['HTTP_HOST'],'user_id'=>0),array('domain'=>$_SERVER['HTTP_HOST']));
        }
		$domain_id = $wpdb->get_var('SELECT domain_id FROM '.Sct_Admin::$table['domain'].' WHERE user_id="'.Sct_Base::getActorUserId().'" and domain = "'.addslashes($_SERVER['HTTP_HOST']).'"');
		if (!(int)$domain_id)
		{
            $get_one = $wpdb->get_results("select * from ".Sct_Admin::$table['click']." where user_id='0'",ARRAY_A);
            if(count($get_one)>0){
                $wpdb->update(Sct_Admin::$table['click'],array('user_id'=>Sct_Base::getActorUserId()),array('user_id'=>0));
            }
            $get_two = $wpdb->get_results("select * from ".Sct_Admin::$table['funnel']." where user_id='0'",ARRAY_A);
            if(count($get_two)>0){
                $wpdb->update(Sct_Admin::$table['funnel'],array('user_id'=>Sct_Base::getActorUserId()),array('user_id'=>0));
            }
            $get_three = $wpdb->get_results("select * from ".Sct_Admin::$table['group']." where user_id='0'",ARRAY_A);
            if(count($get_three)>0){
                $wpdb->update(Sct_Admin::$table['group'],array('user_id'=>Sct_Base::getActorUserId()),array('user_id'=>0));
            }
            $get_four = $wpdb->get_results("select * from ".Sct_Admin::$table['domain']." where user_id='0'",ARRAY_A);
            if(count($get_four)>0){
                $wpdb->query("update ".Sct_Admin::$table['domain']." set user_id='".Sct_Base::getActorUserId()."' where user_id='0' and domain!='".addslashes($_SERVER['HTTP_HOST'])."'");
            }
            $get_five = $wpdb->get_results("select * from ".Sct_Admin::$table['link']." where user_id='0'",ARRAY_A);
            if(count($get_five)>0){
                $wpdb->update(Sct_Admin::$table['link'],array('user_id'=>Sct_Base::getActorUserId()),array('user_id'=>0));
            }
            $get_six = $wpdb->get_results("select * from ".Sct_Admin::$table['user_join']." where parent_user_id='0'",ARRAY_A);
            if(count($get_six)>0){
                $wpdb->update(Sct_Admin::$table['user_join'],array('parent_user_id'=>Sct_Base::getActorUserId()),array('parent_user_id'=>0));
            }
		}
        $wpdb->query("ALTER TABLE ".Sct_Admin::$table['link']." ADD `fb_title` TEXT NOT NULL AFTER `javascript`, ADD `fb_description` TEXT NOT NULL AFTER `fb_title`, ADD `fb_image` TEXT NOT NULL AFTER `fb_description`;");
        $wpdb->query("ALTER TABLE ".Sct_Admin::$table['domain']." ADD `primary` INT NOT NULL AFTER `redirect_to_404`;");
        $wpdb->query("ALTER TABLE ".Sct_Admin::$table['link']." ADD `link_ratio` INT NOT NULL AFTER `url`, ADD `link_red` INT NOT NULL AFTER `link_ratio`, ADD `merged_data` TEXT NOT NULL AFTER `link_red`;");
        $wpdb->query("ALTER TABLE ".Sct_Admin::$table['link']." ADD `query_string` INT NOT NULL AFTER `type` ;");
        $wpdb->query("ALTER TABLE ".Sct_Admin::$table['funnel_link_new']." ADD `link_opt` INT NOT NULL AFTER `red_url` ;");
        /*** Update 4.5 END ***/
        $row = $wpdb->get_results(  "SELECT `description` FROM `".Sct_Admin::$table['link']."`" );
        if(empty($row)) {
            $wpdb->query("ALTER TABLE ".Sct_Admin::$table['link']." ADD `description` TEXT NULL DEFAULT NULL AFTER `name`;");
            $wpdb->query("ALTER TABLE ".Sct_Admin::$table['click']." ADD `time_st` INT NOT NULL AFTER `ip`;");
        }
        /*****V6.8.2******/
        $wpdb->query("ALTER TABLE ".Sct_Admin::$table['link']." ADD `link_clicks` INT NULL DEFAULT NULL AFTER `link_ratio`;");
        $wpdb->query("ALTER TABLE ".Sct_Admin::$table['link']." ADD `rotator_type` INT NULL DEFAULT '0' AFTER `url`;");
        $row_has_children = $wpdb->get_results("SELECT `link_id`,`has_children`,`rotator_type` FROM `".Sct_Admin::$table['link']."` where has_children='1' and rotator_type='0'",ARRAY_A);
        if(count($row_has_children)>0){
            foreach($row_has_children as $k=>$v){
                if($v['rotator_type']==0){
                    $wpdb->update(Sct_Admin::$table['link'],array("rotator_type"=>1),array('link_id'=>$v['link_id']));
                }
            }
        }
        /***WINER SCT***/
        $split_testing_rows = $wpdb->get_results(  "SELECT `automatic_winner` FROM `".Sct_Admin::$table['link']."`" );
        if(empty($split_testing_rows)) {
            $wpdb->query("ALTER TABLE ".Sct_Admin::$table['link']." ADD `automatic_winner` INT(1) NULL DEFAULT NULL AFTER `has_children`, ADD `automatic_winner_total_clicks` INT(10) NULL DEFAULT NULL AFTER `automatic_winner`, ADD `automatic_winner_percentage` INT(10) NULL DEFAULT NULL AFTER `automatic_winner_total_clicks`, ADD `split_test_winner` INT(1) NULL DEFAULT NULL  AFTER `automatic_winner_percentage`;");
        } 
        /***WINER SCT***/
        /***UTM****/
        $wpdb->query("ALTER TABLE `".Sct_Admin::$table['link']."` ADD `utm_fields` TEXT NULL DEFAULT NULL AFTER `query_string`;");
        $wpdb->query("ALTER TABLE `".Sct_Admin::$table['click']."` ADD `utm_source` TEXT NULL DEFAULT NULL AFTER `agent`, ADD `utm_medium` TEXT NULL DEFAULT NULL AFTER `utm_source`, ADD `utm_name` TEXT NULL DEFAULT NULL AFTER `utm_medium`, ADD `utm_term` TEXT NULL DEFAULT NULL AFTER `utm_name`, ADD `utm_content` TEXT NULL DEFAULT NULL AFTER `utm_term`;");
        $wpdb->query("ALTER TABLE `".Sct_Admin::$table['click']."` ADD `id` INT NOT NULL AUTO_INCREMENT FIRST, ADD PRIMARY KEY (`id`);");
        /***UTM IN***/
        $wpdb->query("ALTER TABLE `".Sct_Admin::$table['link']."` ADD `utm_in` INT NULL DEFAULT '0' AFTER `utm_fields`;");
        /**CHANGED COLUMNS NAME UTM NAME TO UTMCAMPAIGN**/
        $wpdb->query("ALTER TABLE `".Sct_Admin::$table['click']."` CHANGE `utm_name` `utm_campaign` TEXT CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;");
        $timed_url = $wpdb->get_results(  "SELECT `timed_url` FROM `".Sct_Admin::$table['link']."`" );
        if(empty($timed_url)) {
            $wpdb->query("ALTER TABLE `".Sct_Admin::$table['link']."` ADD `timed_url` TEXT NULL DEFAULT NULL AFTER `is_archived`, ADD `timed_date` VARCHAR(30) NULL DEFAULT NULL AFTER `timed_url`, ADD `timed_time` VARCHAR(10) NULL DEFAULT NULL AFTER `timed_date`;");
        }
        /***V7.1.6****/
        $wpdb->query("CREATE TABLE `".Sct_Admin::$table['split_count']."` ( `id` INT NOT NULL AUTO_INCREMENT , `link_id` INT NOT NULL ,`type_value` INT NOT NULL, `type` VARCHAR(15) NOT NULL , PRIMARY KEY (`id`)) ENGINE = InnoDB;");
        $wpdb->query("ALTER TABLE `".Sct_Admin::$table['click']."` ADD INDEX(`link_id`, `parent_id`, `source_link_id`, `user_id`);");
        //$wpdb->query("ALTER TABLE `".Sct_Admin::$table['link']."` ADD INDEX(`parent_id`, `link_ratio`, `link_clicks`, `link_red`, `split_test_winner`, `goal_link_id`, `total_clicks`, `unique_clicks`, `is_archived`);");
    }
	public static function array_stripslashes($array)
	{
		if (is_array($array))
		{
			foreach ($array as $field => $value)
			{
				if (is_array($value))
				{
					$array[$field] = self::array_stripslashes($value);
				}
				else
				{
					$array[$field] = stripslashes($value);
				}
			}
		}
		return $array;
	}
}